
/* */
#ifdef UNIX
#include <GL/glx.h>
#include <sys/time.h>
#endif /* */
#ifdef WIN32
#include <windows.h>
#endif /* */
#include <GL/gl.h>
//#include <unistd.h>
#include <time.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <malloc.h>

#include <bc.h>
#include <glib.h>
#include <signal.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <gdk-pixbuf/gdk-pixdata.h>

#include <SDL.h>
#include <SDL_audio.h>
#include <SDL_mixer.h>

#include "db.h"
#include "glfont.h"
#include "popup.h"
#include "tga.h"
#ifdef WIN32
#include "trayicon.h"

#define THIS_CLASSNAME      "Popup systray icon"
#define THIS_TITLE          "GymMaster Notifier"

#endif /* */
int FADEOUT_TIME = 500;			 // milli seconds

int FRAMES_PER_SECOND = 30;

float WINDOW_TIME = 2000.0;

float FONT_SCALE = 10.0;

int FONT_FADE = 6;

int FONT_PAD = 5;

int IMAGE_HEIGHT = 100;

int POPUP_X = 10;

int POPUP_Y = 10;

int POPUP_SPACE = 10;

int POPUP_WIDTH = 900;

int TRANS_ON = 1;

int FADING_ON = 1;

int SOUND_ENABLED = 1;

int STACKING_ENABLED = 1;

int OPERATING_MODE = 0;

char *icons = NULL;

int windowsShown = 0;

static int num_waves = 0;

static Mix_Chunk **waves = NULL;

static int audio_open = 0;

static GLuint texKey = 0;

#ifdef UNIX
static int attributeList[] = { GLX_RGBA, None };
static int attributeList2[] = { GLX_RGBA, GLX_DOUBLEBUFFER, None };

static Bool
WaitForNotify(Display * d, XEvent * e, char *arg)
{
	return (e->type == MapNotify) && (e->xmap.window == (Window) arg);
}

#endif /* */

#ifdef WIN32
LPCSTR wszPopupClassName = "PopupClass";

LPCSTR wszWindowTitle = "Popup Notifier";

LRESULT CALLBACK PopupWndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);

HINSTANCE progInstance;

HWND hFadeoutWnd;

int winCounter = 0;

PIXELFORMATDESCRIPTOR pfd;

HWND closewindow;

WNDCLASSEX wc;

#endif /* */
Texture **tx = NULL;				 // P S D E B G A

GLFONT fadefont;

GLFONT opaqfont;

char *fadefontdata = NULL;

char *opaqfontdata = NULL;

int displaywidth;

int displayheight;

// linked list for windows
struct PopupWindow *firstwin = NULL;

struct PopupWindow *currentwin = NULL;

GList *winlist = NULL;

#ifdef UNIX
Display *dpy;

XVisualInfo *vi;

GLXContext cx;

Colormap cmap;

XSetWindowAttributes swa;

Window glWin;						 // needed to initialise opengl before creating popup windows

XEvent glEvent;

#endif /* */
volatile int server_running = 0;

static void
break_handler(int signum)
{
	server_running = 0;
}

static void
getconfig_int(int *var, const char *key)
{
	int ival;

	char *value = bcconfig_getvalue(key);

	if (value)
	{
		ival = atoi(value);
		if (ival)
			*var = ival;
	}
}

static void
getconfig()
{
	int ival;

	char *value;

	value = bcconfig_getvalue("popup_display_time");

	if (value)
	{
		ival = atoi(value);
		if (ival)
			WINDOW_TIME = (float)ival;
	}

	value = bcconfig_getvalue("font_scale");
	if (value)
	{
		ival = atoi(value);
		if (ival)
			FONT_SCALE = (float)ival;
	}

	getconfig_int(&FONT_FADE, "font_fade");
	getconfig_int(&FADEOUT_TIME, "fadeout_time");
	getconfig_int(&FRAMES_PER_SECOND, "frames_per_second");
	getconfig_int(&FONT_PAD, "font_pad");
	getconfig_int(&IMAGE_HEIGHT, "image_height");
	getconfig_int(&POPUP_X, "window_pos_x");
	getconfig_int(&POPUP_Y, "window_pos_y");
	getconfig_int(&POPUP_SPACE, "window_space");
	getconfig_int(&POPUP_WIDTH, "window_width");
	getconfig_int(&OPERATING_MODE, "operatingmode");

	value = bcconfig_getvalue("icons");
	if (value)
		icons = (value);

	STACKING_ENABLED = !(mem_IsTrue(bcconfig_getvalue("stackingdisabled")));
	TRANS_ON = mem_IsTrue(bcconfig_getvalue("transenabled"));
	FADING_ON = mem_IsTrue(bcconfig_getvalue("fadingenabled"));
}

/* indent really hates this function...*/
// main function (header looks messy)
#ifdef WIN32
int WINAPI
WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpszCmdLine, int nCmdShow)
#endif
#if 0
{														 /* need a function body here to keep indent happy */
}
#endif
#ifdef UNIX
int
main(int argc, char **argv)
#endif
{
	int nextFrameTime;

// int timediff;
	int timedelta;
	GList *walk;

#ifdef WIN32
	MSG msg;

	progInstance = hInstance;
	HWND hWnd = NULL;

	gchar **argv;

	int argc;

	LPWSTR *szArglist;

	int i;

	szArglist = CommandLineToArgvW(GetCommandLineW(), &argc);
	if (NULL == szArglist)
	{
		wprintf(L"CommandLineToArgvW failed\n");
		return 0;
	}

	/* convert to utf-8 */
	/* can't use mem_* funcs yet - so be careful */
	argv = g_malloc(1 + argc * sizeof(char *));

	for (i = 0; i < argc; i++)
		argv[i] = g_utf16_to_utf8(szArglist[i], -1, NULL, NULL, NULL);
	argv[argc] = NULL;

	LocalFree(szArglist);

	if (argv[0] && strlen(argv[0]) > 8)		 // strip .test from filename where present
	{
		gchar *s = argv[0] + strlen(argv[0]) - 9;

		if (!g_ascii_strcasecmp(s + 4, ".test"))
			strcpy(s + 4, ".exe");
		if (!g_ascii_strcasecmp(s, ".test.exe"))
			strcpy(s, ".exe");
	}

#endif
	fprintf(stderr, "Application started.\n");
	fflush(NULL);

	//checkGLErrors("Clear 0");
	// database init stuff
	fprintf(stderr, "bc()\n");
	fflush(NULL);
	bc_init(argc, argv);
	fprintf(stderr, "GTK()\n");
	fflush(NULL);
	gtk_init(&argc, &argv);
	fprintf(stderr, "getConfig()\n");
	fflush(NULL);
	getconfig();
	fprintf(stderr, "Init()\n");
	fflush(NULL);

	if (init())
	{
		fprintf(stderr, "init failed\n");;
		fflush(NULL);
		exit(1);
	}

	fprintf(stderr, "Sound()\n");
	fflush(NULL);
	if (initSound())
	{
		fprintf(stderr, "initSound failed\n");;
		fflush(NULL);
		/* if the sound set up fails then we'll just say there is no sound */
		SOUND_ENABLED = 0;
	}

	/* initialise open gl */
	fprintf(stderr, "GL()\n");
	fflush(NULL);
	if (initGL())
	{
		fprintf(stderr, "initGL failed\n");
		fflush(NULL);
		exit(1);										 /* can't live withoiut GL */
	}

	fprintf(stderr, "Sigs()\n");
	fflush(NULL);
	signal(SIGINT, break_handler);
	signal(SIGABRT, break_handler);

#ifdef UNIX
	signal(SIGHUP, break_handler);
#endif
#ifdef WIN32
	signal(SIGBREAK, break_handler);
	signal(SIGTERM, break_handler);
#endif

	fprintf(stderr, "Getting time start\n");
	fflush(NULL);
	nextFrameTime = 0;
	msecs();											 /* init timer func... */
	// start main loop 
	server_running = 1;
	fprintf(stderr, "Calc time intervals\n");
	fflush(NULL);
	timedelta = (FADEOUT_TIME / ((FADEOUT_TIME * FRAMES_PER_SECOND) / 1000));

	// printf("Fo=%d fps=%d\n",FADEOUT_TIME,FRAMES_PER_SECOND);
#ifdef WIN32
	fprintf(stderr, "Register main window class\n");
	fflush(NULL);
	RegisterMainWndClass(hInstance);
// can't find this defined anywhere...

	fprintf(stderr, "Created window\n");
	fflush(NULL);
	hWnd = CreateWindow(THIS_CLASSNAME, THIS_TITLE, 0, 0, 0, 100, 100, NULL, NULL, hInstance, NULL);

	if (!hWnd)
	{
		MessageBox(NULL, "Ack! I can't create the window!", THIS_TITLE, MB_ICONERROR | MB_OK | MB_TOPMOST);
		return 1;
	}
#endif
	if (SOUND_ENABLED)
	{
		printf("Sound enabled.\n");
	}
	else
	{
		printf("Sound not enabled.\n");
	};
	printf("Operating mode = %d\n", OPERATING_MODE);

	fprintf(stderr, "Starting main loop\n");
	fflush(NULL);
	while (server_running)
	{
#ifdef WIN32
		if (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
		{
			if (msg.message == WM_CLOSE)
				server_running = 0;
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
#endif

		nextFrameTime -= msecs();
		if (nextFrameTime < -timedelta)
			nextFrameTime = -timedelta;
		if (nextFrameTime <= 0)
		{

			nextFrameTime += timedelta;

			waitfornotify(1);
			{
				for (walk = g_list_first(winlist); walk != NULL; walk = walk->next)
				{

					if (!walk->data)
						continue;
					currentwin = walk->data;
					currentwin->frames += (float)timedelta / FADEOUT_TIME;

					if (STACKING_ENABLED == FALSE && walk->next != NULL)
					{
						destroyWindow(currentwin);
						walk->data = NULL;
						break;
					}

					if (currentwin->frames < 1.1)
					{
						renderTag(currentwin);

					}

					else
#ifdef WIN32
					if (currentwin->frames * FADEOUT_TIME >= WINDOW_TIME || currentwin->win == closewindow)	// frames *
						// fadeout
						// time =
						// seconds
						// passed

#endif
#ifdef UNIX
						if (currentwin->frames * FADEOUT_TIME >= WINDOW_TIME)	// frames * fadeout time = seconds passed
#endif
						{
#ifdef WIN32
							closewindow = NULL;
#endif
							destroyWindow(currentwin);

							windowsShown++;

							printf("Windows Shown %d\n", windowsShown);

							walk->data = NULL;
						}
				}
				// remove items not needed anymore
				winlist = g_list_remove_all(winlist, NULL);
			}
		}
		else
			waitfornotify(nextFrameTime);
	}

#ifdef WIN32
	OnClose(hWnd);
#endif
	disConnectDB();
	mem_display();
	bc_cleanup();
	printf("End of loop, shutting down");
#ifdef UNIX
	return 0;
#endif
#ifdef WIN32
	UnregisterClass(wc.lpszClassName, wc.hInstance);	// remove systray item?
	return (int)msg.wParam;
#endif
}

/* *INDENT-ON* */
void
findFreePopupSpot(int winheight, int *xPos, int *yPos)
{

	// find where to put the window
	GList *walk;

	int yspot = POPUP_Y;

	int foundspot = 0;

	if (!STACKING_ENABLED)
	{
		*xPos = POPUP_X;
		*yPos = POPUP_Y;
		return;
	}
	while (foundspot == 0)
	{
		foundspot = 1;
		for (walk = g_list_first(winlist); walk != NULL; walk = walk->next)

		{
			if (walk->data)
			{
				if (((PopupWindow *) (walk->data))->yPos == yspot)
				{
					yspot += ((PopupWindow *) (walk->data))->height + POPUP_SPACE;
					foundspot = 0;
					break;
				}
			}
		}
		if (foundspot == 1)
		{
			for (walk = g_list_first(winlist); walk != NULL; walk = walk->next)

			{
				if (walk->data)
				{
					if (((PopupWindow *) (walk->data))->yPos - POPUP_SPACE < yspot + winheight &&
						 ((PopupWindow *) (walk->data))->yPos - POPUP_SPACE > yspot)
					{
						yspot = ((PopupWindow *) (walk->data))->yPos + ((PopupWindow *) (walk->data))->height + POPUP_SPACE;
						foundspot = 0;
						break;
					}
				}
			}
		}
	}
	*yPos = yspot;
	*xPos = POPUP_X;
}

void
createWindow(struct PopupWindow *pw, Texture * tex, char *name, long colour, char *message, long colour2,
				 char *alerts, int limitimage)
{
	float x, y, x2, y2, imgSpace;

	pw->imageheight = (limitimage || tex == NULL) ? IMAGE_HEIGHT : tex->trueheight;
	imgSpace =
		(tex ==
		 NULL ? ((alerts == NULL || alerts[0] == '\0') ? 0 : pw->imageheight) : pw->imageheight * tex->aspectratio);
	glFontBegin(&fadefont);
	glFontStringSize(name, (float)(POPUP_WIDTH - imgSpace) / FONT_SCALE, &x, &y);
	glFontStringSize(message, (float)(POPUP_WIDTH - imgSpace) / FONT_SCALE, &x2, &y2);
	glFontEnd();
	printf("message %s, alerts: %s\n", message, alerts);
	y = y + y2;
	x = max(x, x2);
	pw->width = imgSpace + FONT_PAD + x * FONT_SCALE;	// width;
	pw->height =
		max((tex == NULL ? 0 : pw->imageheight) + ((strlen(alerts) == 0) ? 0 : imgSpace / max(strlen(alerts), 2)),
			 y * FONT_SCALE);
	findFreePopupSpot(pw->height, &pw->xPos, &pw->yPos);

	// pw->xPos = 10;
	// pw->yPos = 10;
	pw->tex = tex;
	pw->name = mem_strdup(name);
	pw->message = mem_strdup(message);
	pw->alerts = mem_strdup(alerts);
	pw->colour = colour;
	pw->colour2 = colour2;
	pw->frames = 0.0;
	pw->drawcount = 0;

#ifdef UNIX
	pw->win =
		XCreateWindow(dpy, RootWindow(dpy, vi->screen), pw->xPos, pw->yPos, pw->width, pw->height, 0, vi->depth,
						  InputOutput, vi->visual, CWColormap | CWEventMask | CWOverrideRedirect, &swa);
	XMapWindow(dpy, pw->win);
	XIfEvent(dpy, &(pw->event), WaitForNotify, (char *)pw->win);

	/* connect the context to the window */
	glXMakeCurrent(dpy, pw->win, cx);

#endif /* */
#ifdef WIN32
	// Choose a pixel format according to the parameters
	ZeroMemory(&pfd, sizeof(pfd));
	pfd.nSize = sizeof(pfd);
	pfd.nVersion = 1;
	if (TRANS_ON)
		pfd.dwFlags = PFD_DRAW_TO_WINDOW | PFD_SUPPORT_OPENGL;

	else
		pfd.dwFlags = PFD_DRAW_TO_WINDOW | PFD_SUPPORT_OPENGL | PFD_DOUBLEBUFFER;
	pfd.iPixelType = PFD_TYPE_RGBA;
	pfd.iLayerType = PFD_MAIN_PLANE;
	pfd.cColorBits = 24;
	pfd.cAlphaBits = 0;
	pfd.cDepthBits = 0;
	pfd.cStencilBits = 0;

	// Create the popup window
	pw->win =
		CreateWindowEx(0x08000000L | WS_EX_TOPMOST, wszPopupClassName, wszWindowTitle, WS_POPUP | WS_VISIBLE,
							pw->xPos, pw->yPos, pw->width, pw->height, NULL, NULL, progInstance, NULL);

	// Get a device context for the window
	pw->context = GetDC(pw->win);

	// SetWindowPos(pw->win, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE|SWP_NOSIZE);
	if (!SetPixelFormat(pw->context, ChoosePixelFormat(pw->context, &pfd), &pfd))

	{
		ReleaseDC(pw->win, pw->context);
		return;
	}
	// Create the render context
	pw->rendcontext = wglCreateContext(pw->context);
	if (!pw->rendcontext)

	{
		ReleaseDC(pw->win, pw->context);
		return;
	}
	wglMakeCurrent(pw->context, pw->rendcontext);
	initWinFont();
	initWinIcons();

#endif /* */
	if (tex != NULL)
		initTexture(tex);
}

void
destroyWindow(struct PopupWindow *pw)
{

#ifdef UNIX
	glXMakeCurrent(dpy, glWin, cx);
	XDestroyWindow(dpy, pw->win);
	XSync(dpy, FALSE);

#endif /* */
#ifdef WIN32
	wglMakeCurrent(NULL, NULL);
	ReleaseDC(pw->win, pw->context);
	wglDeleteContext(pw->rendcontext);
	DestroyWindow(pw->win);

#endif /* */
	if (pw->tex != NULL)
	{
		// mem_free(pw->tex->imageData); glDeleteTextures(1, &(pw->tex->texID));

	}
	mem_free(pw->name);
	mem_free(pw->message);
	mem_free(pw->alerts);
	mem_free(pw->tex);
	mem_free(pw);
}

#ifdef WIN32
LRESULT CALLBACK
PopupWndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)

	{
		case WM_LBUTTONUP:

		{
			closewindow = hWnd;
			return 0;
		}

			/* case WM_CREATE: {

			   return 0; }

			   case WM_PAINT: { //renderTag((struct PopupWindow *)lParam); return 0; } */
	}
	return DefWindowProc(hWnd, message, wParam, lParam);
}

#endif /* */
int
init()
{

#ifdef UNIX
	/* get a connection */
	fprintf(stderr, "	XOpenDisplay(0)\n");
	fflush(NULL);
	dpy = XOpenDisplay(0);
	if (dpy == NULL)
	{
		fprintf(stderr, "Could not open the display\n");
		fflush(NULL);
	}

	/* get an appropriate visual */
	fprintf(stderr, "	glXChooseVisual()\n");
	fflush(NULL);
	if (TRANS_ON)
		vi = glXChooseVisual(dpy, DefaultScreen(dpy), attributeList);

	else
		vi = glXChooseVisual(dpy, DefaultScreen(dpy), attributeList2);
	if (vi == NULL)
	{
		fprintf(stderr, "Could not choose appropriate visual settings\n");
		fflush(NULL);
	}

	/* create a GLX context */
	fprintf(stderr, "	glXCreateContext()\n");
	fflush(NULL);
	cx = glXCreateContext(dpy, vi, 0, GL_TRUE);
	if (cx == NULL)
	{
		fprintf(stderr, "Could not create openGL context\n");
		fflush(NULL);
	}

	/* create a color map */
	fprintf(stderr, "	XCreateColormap()\n");
	fflush(NULL);
	cmap = XCreateColormap(dpy, RootWindow(dpy, vi->screen), vi->visual, AllocNone);
	if (cmap == 0)
	{
		fprintf(stderr, "Could not create colour map\n");
		fflush(NULL);
	}
	fprintf(stderr, "	DisplaySize()\n");
	fflush(NULL);
	displaywidth = DisplayWidth(dpy, 0);
	displayheight = DisplayHeight(dpy, 0);

	/* create window attributes */
	fprintf(stderr, "	Set window attribs\n");
	fflush(NULL);
	swa.colormap = cmap;
	swa.override_redirect = 1;

	// swa.border_pixel = 0;
	swa.event_mask = StructureNotifyMask;

#endif /* */

#ifdef WIN32
	// Register window classes
	fprintf(stderr, "	ZeroMemory()\n");
	fflush(NULL);
	ZeroMemory(&wc, sizeof(wc));
	fprintf(stderr, "	Setup window properties\n");
	fflush(NULL);
	wc.cbSize = sizeof(wc);

	// wc.style = CS_HREDRAW | CS_VREDRAW | CS_OWNDC;
	wc.hInstance = progInstance;
	wc.lpszClassName = wszPopupClassName;
	wc.lpfnWndProc = &PopupWndProc;
	fprintf(stderr, "	LoadIcon()\n");
	fflush(NULL);
	wc.hIcon = wc.hIconSm = LoadIcon(NULL, IDI_APPLICATION);
	fprintf(stderr, "	RegisterClassEx()\n");
	fflush(NULL);
	if (!RegisterClassEx(&wc))
	{
		printf("Can't create window!");
		return 1;
	}
#endif /* */
	return 0;
}

int
initSound()
{
	int x;

	char *s;

	fprintf(stderr, "	bcconfig_getvalue()\n");
	fflush(NULL);
	s = bcconfig_getvalue("sounds");
	fprintf(stderr, "	get the number of wave files\n");
	fflush(NULL);
	num_waves = (s ? atoi(s) : 4) + 1;
	fprintf(stderr, "	calloc()\n");
	fflush(NULL);
	waves = calloc(num_waves, sizeof(Mix_Chunk *));
	fprintf(stderr, "	bcconfig_getvalue(sound enabled?)\n");
	fflush(NULL);
	if (!mem_IsTrue(bcconfig_getvalue("soundenabled")))
	{
		SOUND_ENABLED = 0;
		return 0;
	}
	fprintf(stderr, "	SDL_Init()\n");
	fflush(NULL);
	if (SDL_Init(SDL_INIT_AUDIO) < 0)
	{
		fprintf(stderr, "Couldn't initialize SDL: %s\n", SDL_GetError());
		fflush(NULL);
		return 1;
	}
	fprintf(stderr, "	Mix_OpenAudio()\n");
	fflush(NULL);
	if (Mix_OpenAudio(MIX_DEFAULT_FREQUENCY, MIX_DEFAULT_FORMAT, 2, 4096) < 0)
	{
		fprintf(stderr, "Couldn't open audio: %s\n", SDL_GetError());
		fflush(NULL);
		return 1;
	}
	audio_open = 1;
	fprintf(stderr, "	Loop through sound files\n");
	fflush(NULL);
	for (x = 0; x < num_waves; x++)
	{
		char *configitem;

		char *filename;

		fprintf(stderr, "	Make string soundwave[]\n");
		fflush(NULL);
		configitem = mem_strdup_printf("soundwave[%d]", x);
		fprintf(stderr, "	bcconfig_getvalue()\n");
		fflush(NULL);
		filename = bcconfig_getvalue(configitem);
		fprintf(stderr, "	If valid then:\n");
		fflush(NULL);
		if (filename)
		{
			fprintf(stderr, "	Load wave file\n");
			fflush(NULL);
			waves[x] = Mix_LoadWAV(filename);
			if (waves[x] == NULL)
			{
				fprintf(stderr, "Couldn't load %s: %s\n", filename, SDL_GetError());
				fflush(NULL);
			}
		}
		else
		{
			if (x)
				fprintf(stderr, "no %s defined\n", configitem);
			fflush(NULL);
			waves[x] = NULL;
		}
		mem_free(configitem);
	}
	return 0;
}

int
initGL()
{

#ifdef UNIX
	fprintf(stderr, "	XCreateWindow()\n");
	fflush(NULL);
	glWin =
		XCreateWindow(dpy, RootWindow(dpy, vi->screen), 0, 0, 1, 1, 0, vi->depth, InputOutput, vi->visual,
						  CWColormap | CWEventMask | CWOverrideRedirect, &swa);
	fprintf(stderr, "	glXMakeCurrent()\n");
	fflush(NULL);
	glXMakeCurrent(dpy, glWin, cx);
	if (TRANS_ON)
	{
		fprintf(stderr, "	glEnable(GL_BLEND)-0\n");
		fflush(NULL);
		glEnable(GL_BLEND);
		if (checkGLErrors("glEnable(GL_BLEND)"))
			return 1;
		glBlendFunc(GL_ONE_MINUS_SRC_ALPHA, GL_SRC_ALPHA);
		if (checkGLErrors("glBlendFunc(GL_ONE_MINUS_SRC_ALPHA, GL_SRC_ALPHA)"))
			return 1;
	}
	fprintf(stderr, "	Set up perspective\n");
	fflush(NULL);
	glMatrixMode(GL_PROJECTION);
	if (checkGLErrors("glMatrixMode(GL_PROJECTION)"))
		return 1;
	glLoadIdentity();
	if (checkGLErrors("glLoadIdentity()"))
		return 1;
	glOrtho(0, 100, 0, 100, -1, 1);
	if (checkGLErrors("glOrtho(0, 100, 0, 100, -1, 1)"))
		return 1;
	glClearColor(0, 0, 0, 1);
	if (checkGLErrors("glClearColor(0,0,0,1)"))
		return 1;
	glEnable(GL_TEXTURE_2D);
	if (checkGLErrors("glEnable(GL_TEXTURE_2D)"))
		return 1;

#endif /* */
	fprintf(stderr, "	Load Icons\n");
	fflush(NULL);
	if (LoadIcons())
		return 1;

#ifdef UNIX
	fprintf(stderr, "	initWinIcons()\n");
	fflush(NULL);
	if (initWinIcons())
		return 1;

#endif /* */
	fprintf(stderr, "	Load Font\n");
	fflush(NULL);
	if (LoadFont())
		return 1;
	return 0;
}

int
LoadFont()
{
	GLuint texid;

	GLuint texid2;

	fprintf(stderr, "		Get font config\n");
	fflush(NULL);
	gchar *font = bcconfig_getvalue("font");

#ifdef WIN32
	if (!font)
		font = "popup/fonts/consol22.glf";

#else	/* */
	if (!font)
		font = "./fonts/consol22.glf";

#endif /* */
	// glGenTextures(1, &texid);
	texid = texKey++;

	// printf("loading id: %d\n", texid);
	fprintf(stderr, "		Create fade font\n");
	fflush(NULL);
	fadefontdata = glFontCreate(&fadefont, font, texid, FONT_FADE, FADING_ON);
	if (!fadefontdata)

	{
		fprintf(stderr, "Can't load transparent font:%s\n", font);
		fflush(NULL);
		return 1;
	}
	// glGenTextures(1, &texid2);
	texid2 = texKey++;

	// printf("loading id: %d\n", texid2);
	fprintf(stderr, "		Create opaque font\n");
	fflush(NULL);
	opaqfontdata = glFontCreate(&opaqfont, font, texid2, 1, FADING_ON);
	if (!fadefontdata)

	{
		fprintf(stderr, "Can't load opaque font:%s\n", font);
		fflush(NULL);
		return 1;
	}
	return 0;
}

int
initTexture(Texture * tex)
{

	// glEnable(GL_BLEND);
	// glBlendFunc(GL_ONE_MINUS_SRC_ALPHA, GL_SRC_ALPHA);
	// printf("%d, %d, %d\n",tex->width, tex->height, tex->channels);

	// initialising the image data for the individual window
	// glGenTextures(1, &(tex->texID));
	if (tex == NULL)
	{
		fprintf(stderr, "Texture is NULL\n");
		fflush(NULL);
		return 1;
	}
	else if (tex->imageData == NULL)
	{
		fprintf(stderr, "Texture is empty\n");
		fflush(NULL);
		return 1;
	}
	tex->texID = texKey++;
	glBindTexture(GL_TEXTURE_2D, tex->texID);	// Use this texture
	if (checkGLErrors("glBindTexture(GL_TEXTURE_2D, tex->texID) - initTexture()"))
		return 1;
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
	if (checkGLErrors("glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP) - initTexture()"))
		return 1;
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
	if (checkGLErrors("glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP) - initTexture()"))
		return 1;
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	if (checkGLErrors("glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR) - initTexture()"))
		return 1;
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	if (checkGLErrors("glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR) - initTexture()"))
		return 1;
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
	if (checkGLErrors("glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST) - initTexture()"))
		return 1;
	glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
	if (checkGLErrors("glTexEnvi(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE) - initTexture()"))
		return 1;
	if (tex->channels == 3)
	{
		glTexImage2D(GL_TEXTURE_2D, 0, 3, tex->width, tex->height, 0, GL_RGB, GL_UNSIGNED_BYTE, tex->imageData);
		if (checkGLErrors
			 ("glTexImage2D(GL_TEXTURE_2D, 0, 3, tex->width, tex->height, 0, GL_RGB, GL_UNSIGNED_BYTE, tex->imageData) - initTexture()"))
			return 1;
	}
	else if (tex->channels == 4)
	{
		glTexImage2D(GL_TEXTURE_2D, 0, 4, tex->width, tex->height, 0, GL_RGBA, GL_UNSIGNED_BYTE, tex->imageData);
		if (checkGLErrors
			 ("glTexImage2D(GL_TEXTURE_2D, 0, 4, tex->width, tex->height, 0, GL_RGBA, GL_UNSIGNED_BYTE, tex->imageData) - initTexture()"))
			return 1;
	}
	else if (tex->channels == 1)
	{
		glTexImage2D(GL_TEXTURE_2D, 0, 1, tex->width, tex->height, 0, GL_LUMINANCE, GL_UNSIGNED_BYTE, tex->imageData);
		if (checkGLErrors
			 ("glTexImage2D(GL_TEXTURE_2D, 0, 1, tex->width, tex->height, 0, GL_LUMINANCE, GL_UNSIGNED_BYTE, tex->imageData) - initTexture()"))
			return 1;
	}
	glEnable(GL_TEXTURE_2D);
	if (checkGLErrors("glEnable(GL_TEXTURE_2D) - initTexture()"))
		return 1;
	return 0;
}

int
initWinFont()
{
	if (fadefont.Char == NULL || opaqfont.Char == NULL)
	{
		fprintf(stderr, "Fonts not loaded when trying to run initWinFont()\n");
		fflush(NULL);
		return 1;
	}
	// reinitialising the text texture for the individual window
	glBindTexture(GL_TEXTURE_2D, fadefont.Tex);
	if (checkGLErrors("glBindTexture(GL_TEXTURE_2D, fadefont.Tex) - initWinFont()"))
		return 1;
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
	if (checkGLErrors("glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP) - initWinFont()"))
		return 1;
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
	if (checkGLErrors("glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP) - initWinFont()"))
		return 1;
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	if (checkGLErrors("glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR) - initWinFont()"))
		return 1;
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	if (checkGLErrors("glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR) - initWinFont()"))
		return 1;
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
	if (checkGLErrors("glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE) - initWinFont()"))
		return 1;
	glTexImage2D(GL_TEXTURE_2D, 0, 2, fadefont.TexWidth, fadefont.TexHeight, 0, GL_LUMINANCE_ALPHA,
					 GL_UNSIGNED_BYTE, (void *)fadefontdata);
	if (checkGLErrors("glTexImage2D(fadefont) - initWinFont()"))
		return 1;
	glEnable(GL_TEXTURE_2D);
	if (checkGLErrors("glEnable(GL_TEXTURE_2D) - initWinFont()"))
		return 1;
	glBindTexture(GL_TEXTURE_2D, opaqfont.Tex);
	if (checkGLErrors("glBindTexture(GL_TEXTURE_2D, opaqfont.Tex) - initWinFont()"))
		return 1;
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
	if (checkGLErrors("glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP) - initWinFont()"))
		return 1;
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
	if (checkGLErrors("glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP) - initWinFont()"))
		return 1;
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	if (checkGLErrors("glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR) - initWinFont()"))
		return 1;
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	if (checkGLErrors("glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR) - initWinFont()"))
		return 1;
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
	if (checkGLErrors("glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE) - initWinFont()"))
		return 1;
	glTexImage2D(GL_TEXTURE_2D, 0, 2, opaqfont.TexWidth, opaqfont.TexHeight, 0, GL_LUMINANCE_ALPHA,
					 GL_UNSIGNED_BYTE, (void *)opaqfontdata);
	if (checkGLErrors("glTexImage2D(opaqfont) - initWinFont()"))
		return 1;
	glEnable(GL_TEXTURE_2D);
	if (checkGLErrors("glEnable(GL_TEXTURE_2D) - initWinFont()"))
		return 1;
	return 0;
}

int
initWinIcons()
{

	// reinitialising the icon textures for the individual window
	int i;

	if (icons == NULL)
	{
		fprintf(stderr, "Icons not defined for initWinIcons()\n");
		fflush(NULL);
		return 1;
	}
	for (i = 0; i < strlen(icons); i++)
	{

		// printf("reinit icon %c, size %dx%d, texid:%d\n", icons[i],tx[i]->width, tx[i]->height,tx[i]->texID);
		glBindTexture(GL_TEXTURE_2D, tx[i]->texID);
		if (checkGLErrors("glBindTexture(GL_TEXTURE_2D, tx[i]->texID) - initWinIcons()"))
			return 1;
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
		if (checkGLErrors("glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP) - initWinIcons()"))
			return 1;
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
		if (checkGLErrors("glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP) - initWinIcons()"))
			return 1;
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
		if (checkGLErrors("glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR) - initWinIcons()"))
			return 1;
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
		if (checkGLErrors("glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR) - initWinIcons()"))
			return 1;
		glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
		if (checkGLErrors("glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE) - initWinIcons()"))
			return 1;
		glTexImage2D(GL_TEXTURE_2D, 0, 3, tx[i]->width, tx[i]->height, 0, GL_RGB, GL_UNSIGNED_BYTE, tx[i]->imageData);
		if (checkGLErrors
			 ("glTexImage2D(GL_TEXTURE_2D, 0, 3, tx[i]->width, tx[i]->height, 0, GL_RGB, GL_UNSIGNED_BYTE, tx[i]->imageData) - initWinIcons()"))
			return 1;
		glEnable(GL_TEXTURE_2D);
		if (checkGLErrors("glEnable(GL_TEXTURE_2D) - initWinIcons()"))
			return 1;
	}
	return 0;
}

void
renderTag(struct PopupWindow *pw)
{
	int i, j, l;

	float wid;

#ifdef UNIX
	glXMakeCurrent(dpy, pw->win, cx);

#endif /* */
#ifdef WIN32
	wglMakeCurrent(pw->context, pw->rendcontext);

#endif /* */
	if (!TRANS_ON)
		glClear(GL_COLOR_BUFFER_BIT);
	glViewport(0, 0, pw->width, pw->height);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrtho(0, pw->width, 0, pw->height, -1, 1);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

/*	if(pw->frames < 20){
	} else {
		if(windowWipeLeft){
			windowPosX--;
			if(windowPosX+windowWidth >= 0)
				SetWindowPos(hFadeoutWnd, HWND_TOPMOST, windowPosX, windowPosY, 0, 0, SWP_NOSIZE);
			
		}else{
			windowPosX++;
			if(windowPosX <= GetSystemMetrics(SM_CXSCREEN))
				SetWindowPos(hFadeoutWnd, HWND_TOPMOST, windowPosX, windowPosY, 0, 0, SWP_NOSIZE);
		}
	
	}*/

	/* show member photo */
	if (TRANS_ON)
	{

#ifndef RELEASE
		fprintf(stderr, "	glEnable(GL_BLEND)-1\n");
		fflush(NULL);

#endif /* */
		glEnable(GL_BLEND);
		glBlendFunc(GL_ONE_MINUS_SRC_ALPHA, GL_SRC_ALPHA);
	}
	if (pw->tex != NULL)
	{
		glBindTexture(GL_TEXTURE_2D, pw->tex->texID);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
		if (pw->frames < 1.0 && FADING_ON)
		{
			glColor4f(1.0, 1.0, 1.0, (float)(0.9 - pw->frames) / (1.0 - pw->frames));
		}
		else
		{
			glColor4f(1.0, 1.0, 1.0, 0.0);
		}
		glBegin(GL_TRIANGLE_STRIP);
		glTexCoord2f(1.0, 1.0);
		glVertex2f(pw->imageheight * pw->tex->aspectratio, pw->height);
		glTexCoord2f(0.0, 1.0);
		glVertex2f(0.0, pw->height);
		glTexCoord2f(1.0, 0.0);
		glVertex2f(pw->imageheight * pw->tex->aspectratio, pw->height - pw->imageheight);
		glTexCoord2f(0.0, 0.0);
		glVertex2f(0.0, pw->height - pw->imageheight);
		glEnd();
		glBindTexture(GL_TEXTURE_2D, 0);
	}

	/* show alert icons */
	l = strlen(pw->alerts);
	for (i = 0; i < l; i++)
	{
		for (j = 0; j < strlen(icons); j++)
		{
			if (icons[j] == pw->alerts[i])
			{

				// printf("%s:%d - %s:%d icon\n", pw->alerts, i, icons, j);
				glBindTexture(GL_TEXTURE_2D, tx[j]->texID);
				glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
				glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
				break;
			}
		}

		// printf("%c icon\n", pw->alerts[i]);
		if (pw->frames < 1.0 && FADING_ON)
		{
			glColor4f(1.0, 1.0, 1.0, (float)(0.9 - pw->frames) / (1.0 - pw->frames));
		}
		else
		{
			glColor4f(1.0, 1.0, 1.0, 0.0);
		}
		wid = ((pw->tex == NULL ? pw->imageheight : pw->imageheight * pw->tex->aspectratio) / (float)max(l, 2));
		glBegin(GL_TRIANGLE_STRIP);
		glTexCoord2f(1.0, 1.0);
		glVertex2f(wid * (i + 1), pw->height - (pw->tex == NULL ? 0 : pw->imageheight));
		glTexCoord2f(0.0, 1.0);
		glVertex2f(wid * i, pw->height - (pw->tex == NULL ? 0 : pw->imageheight));
		glTexCoord2f(1.0, 0.0);
		glVertex2f(wid * (i + 1), pw->height - (pw->tex == NULL ? 0 : pw->imageheight) - wid);
		glTexCoord2f(0.0, 0.0);
		glVertex2f(wid * i, pw->height - (pw->tex == NULL ? 0 : pw->imageheight) - wid);
		glEnd();
		glBindTexture(GL_TEXTURE_2D, 0);
	}
	/* write text */
	if ((pw->drawcount < FONT_FADE * 1.5 && TRANS_ON && FADING_ON) || !TRANS_ON || !FADING_ON)
	{
		float x = 0.0, y = 0.0, z = 0.0;

		pw->drawcount++;
		glPushMatrix();
		if (pw->drawcount < FONT_FADE * 1.5)
		{
			glFontBegin(&fadefont);
		}
		else
		{
			glFontBegin(&opaqfont);
		}
		glTranslatef(((pw->tex ==
							NULL ? ((pw->alerts == NULL || pw->alerts[0] == '\0') ? 0 : pw->imageheight) : pw->imageheight *
							pw->tex->aspectratio) + FONT_PAD), pw->height, 0);
		glScalef(FONT_SCALE, FONT_SCALE, 1.0);
		glColor4f(((pw->colour >> 16) & 0x0000FF) / 255.0, ((pw->colour >> 8) & 0x0000FF) / 255.0,
					 (pw->colour & 0x0000FF) / 255.0, 1.0);

		// glColor4b(255, 255, 0, 128);
		glFontTextOut(pw->name, &x, &y, &z);

		// glColor4b(((pw->colour >> 16) & 0x0000FF), ((pw->colour >> 8) & 0x0000FF), (pw->colour & 0x0000FF), 255);
		glColor4f(((pw->colour2 >> 16) & 0x0000FF) / 255.0, ((pw->colour2 >> 8) & 0x0000FF) / 255.0,
					 (pw->colour2 & 0x0000FF) / 255.0, 1.0);
		glFontTextOut(pw->message, &x, &y, &z);
		glFontEnd();
		glPopMatrix();
	}
	glFinish();

#ifdef WIN32
	if (!TRANS_ON)
		SwapBuffers(pw->context);

#endif /* */
#ifdef UNIX
	if (!TRANS_ON)
		glXSwapBuffers(dpy, pw->win);

#endif /* */
	glFlush();
}

int
soundeffect(char c)
{

	printf("In soundeffect function./n");
	if (SOUND_ENABLED)

	{
		int v = c - '0';

		if (v >= 0 && v < num_waves)

		{

			// printf("Playing waves[%d]\n",v);
			Mix_PlayChannel(0, waves[v], 0);
		}

		else

		{

			// printf("Playing default sound, waves[0]\n");
			Mix_PlayChannel(0, waves[0], 0);
		}
	}
	return 0;
}

int
LoadIcons()							 // Load Bitmaps And Convert To Textures
{
	char *configitem;

	char *filename;

	int i;

	fprintf(stderr, "		Make space for icons\n");
	fflush(NULL);
	tx = mem_calloc(sizeof(void *) * strlen(icons));
	if (tx == NULL)
	{
		fprintf(stderr, "Failed to allocate space for icon textures\n");
		fflush(NULL);
		return 1;
	}
	// if(TRANS_ON){
	// glEnable(GL_TEXTURE);
	// glBlendFunc(GL_ONE_MINUS_SRC_ALPHA, GL_SRC_ALPHA);
	// }
	for (i = 0; i < strlen(icons); i++)
	{
		fprintf(stderr, "		Make space for individual icon\n");
		fflush(NULL);
		tx[i] = mem_calloc(sizeof(Texture));
		if (tx[i] == NULL)
		{
			fprintf(stderr, "Failed to allocate space for individual icon texture\n");
			fflush(NULL);
			return 1;
		}
		fprintf(stderr, "		Get icon name\n");
		fflush(NULL);
		configitem = mem_strdup_printf("icon[%c]", icons[i] - ('A' - 'a'));
		filename = bcconfig_getvalue(configitem);
		if (filename)
		{
			fprintf(stderr, "		Loading texture %s\n", filename);
			fflush(NULL);
			if (LoadTGATexture(tx[i], filename))
			{
				fprintf(stderr, "Could not load icon texture at %s\n", filename);
				fflush(NULL);
				return 1;
			}
			fprintf(stderr, "		Finished loading texture\n");
			fflush(NULL);

			// glGenTextures(1, &texID);
			tx[i]->texID = texKey++;

			/* fprintf(stderr, " Binding texture\n");fflush(NULL); glBindTexture(GL_TEXTURE_2D, tx[i]->texID);
			   if(checkGLErrors("glBindTexture(GL_TEXTURE_2D, tx[i]->texID) - LoadIcons()")) return 1; */
			// printf("loading filename %s, id: %d\n", filename, tx[i]->texID);
		}
		else
		{
			fprintf(stderr, "Couldn't find texture in configuration, %s\n", configitem);
			fflush(NULL);
		}
		mem_free(configitem);
	}
	return 0;
}

/*
#ifdef UNIX
long GetTickCount()
{
    return (clock()/CLOCKS_PER_SEC)*1000;
}
#endif
*/
long
msecs(void)							 // elapsed millicecs since last call (max 60 sec, min 0)
{
	long rv;

#ifdef UNIX
	static struct timeval tv0;

	struct timeval tv;

	gettimeofday(&tv, NULL);
	rv = (tv.tv_usec - tv0.tv_usec) / 1000 + (tv.tv_sec - tv0.tv_sec) * 1000;
	memcpy(&tv0, &tv, sizeof tv);

#endif /* */
#ifdef WIN32
	static DWORD tv0;

	DWORD tv = GetTickCount();

	rv = tv - tv0;
	tv0 = tv;
	
#endif /* */
	return rv < 60000 ?(rv > 0 ? rv : 0) : 60000;
}

int
checkGLErrors(char *funcname)
{
	GLenum err;

	int retval = 0, i;

	for (i = 0; i < 6 && (err = glGetError()) != GL_NO_ERROR; i++)

	{
		switch (err)

		{
			case GL_INVALID_ENUM:
				fprintf(stderr, "Invalid argument for %s (GL_INVALID_ENUM).\n", funcname);
				fflush(NULL);
				retval = 0;
				break;
			case GL_INVALID_VALUE:
				fprintf(stderr, "Invalid value for argument in %s (GL_INVALID_VALUE).\n", funcname);
				fflush(NULL);
				retval = 0;
				break;
			case GL_INVALID_OPERATION:
				fprintf(stderr, "Invalid operation for %s (GL_INVALID_OPERATION).\n", funcname);
				fflush(NULL);
				retval = 0;
				break;
			case GL_STACK_OVERFLOW:
				fprintf(stderr, "Stack overflow for %s (GL_STACK_OVERFLOW).\n", funcname);
				fflush(NULL);
				retval = 0;
				break;
			case GL_STACK_UNDERFLOW:
				fprintf(stderr, "Stack underflow for %s (GL_STACK_UNDERFLOW).\n", funcname);
				fflush(NULL);
				retval = 0;
				break;
			case GL_OUT_OF_MEMORY:
				fprintf(stderr, "Out of memory for %s (GL_OUT_OF_MEMORY).\n", funcname);
				fflush(NULL);
				retval = 1;
				break;
			default:
				fprintf(stderr, "Unknown error with %s.\n", funcname);
				fflush(NULL);
				retval = 0;
		}
	}
	return retval;
}

int

ignoredoor(int doorid)
{
	const char newkey[] = "ignoredoor(%d)";
	static int preload = 1;
	char configitem[50];			 /* there's no way that sprintf of newkey will use this up */
	char *ignoreid=NULL;

	if (preload)				/* first call loads all the settings so that subsequent calls only do a
						  single hash lookup */

	{
		int x;

		for (x = 1; x < 1000; x++)
		{

			sprintf(configitem, "doorignore[%d]", x);
			ignoreid = bcconfig_getvalue(configitem);
			if (ignoreid != NULL)
			{
				//printf ("Ignoring %s for %s\n",configitem,ignoreid);
				//bcconfig_setvalue(configitem, NULL);	/* free old item */
				
				sprintf(configitem, newkey, atoi(ignoreid));

				bcconfig_setvalue(configitem, "1");	/* allocate new item */
				//printf("Returning %s %s \n",configitem,bcconfig_getvalue(configitem));
			}
		}
		preload = 0;
	}
	sprintf(configitem, newkey, doorid);
	if (bcconfig_getvalue(configitem) != NULL)
		return 1;
	return 0;
}

